#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct e {
    int u, c, f, rev;
};

const int N = 200002, K = 7, M = 27 * 27, V = M * 2 + 2;
int d[M], used[M];
vector<e> g[M];
vector<int> ls[M], rs[M];
int a[N][K];
int pw = 1, s, t;
int n, k;

void add_edge(int u, int v, int c) {
    g[u].push_back({v, c, 0, g[v].size()});
    g[v].push_back({u, 0, 0, g[u].size() - 1});
}
void go(int p, int s1, int s2) {
    if (p == k - 1) {
        add_edge(s1, pw + s2, N);
        return;
    }
    for (int i = 0; i < 3; i++)
        for (int j = 0; j < 3; j++)
            if (i != j || (i != 0 && i != 2))
                go(p + 1, s1 * 3 + i, s2 * 3 + j);
}

bool bfs() {
    queue<int> q;
    for (int i = 0; i <= t; i++)
        d[i] = N;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (e &ce : g[v]) {
            if (ce.f < ce.c && d[ce.u] == N) {
                d[ce.u] = d[v] + 1;
                q.push(ce.u);
            }
        }
    }
    return d[t] < N;
}

int dfs(int v, int mf) {
    if (v == t)
        return mf;
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++) {
        e ce = g[v][i];
        if (d[ce.u] != d[v] + 1 || used[ce.u] || ce.f == ce.c)
            continue;
        int nf = dfs(ce.u, min(mf, ce.c - ce.f));
        if (nf > 0) {
            g[v][i].f += nf;
            g[ce.u][ce.rev].f -= nf;
            return nf;
        }
    }
    return 0;
}
int flow() {
    int ans = 0;
    while (bfs()) {
        while (1) {
            memset(used, 0, (t + 1) * sizeof(int));
            int cf = dfs(s, N);
            if (!cf)
                break;
            ans += cf;
        }
    }
    return ans;
}




int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> k;
    vector<int> b(n);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < k; j++)
            cin >> a[i][j];
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < n; j++)
            b[j] = a[j][i];
        sort(b.begin(), b.end());
        int cs = b[n / 2] + b[n / 2 - 1];
        for (int j = 0; j < n; j++) {
            if (a[j][i] * 2 < cs)
                a[j][i] = 0;
            else if (a[j][i] * 2 > cs)
                a[j][i] = 2;
            else
                a[j][i] = 1;
        }
    }
    for (int i = 0; i < k - 1; i++)
        pw *= 3;
    s = pw * 2;
    t = s + 1;
    for (int i = 0; i < n; i++) {
        int pp = 0;
        for (int j = 1; j < k; j++)
            pp = pp * 3 + a[i][j];
        if (a[i][0] == 0)
            ls[pp].push_back(i);
        else
            rs[pp].push_back(i);
    }
    for (int i = 0; i < pw; i++) {
        add_edge(s, i, ls[i].size());
        add_edge(pw + i, t, rs[i].size());
    }
    go(0, 0, 0);
    int fl = flow();
    if (fl < n / 2) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    for (int i = 0; i < pw; i++) {
        for (e &ce : g[i]) {
            if (ce.u == s)
                continue;
            for (int j = 0; j < ce.f; j++) {
                cout << ls[i].back() + 1 << ' ' << rs[ce.u - pw].back() + 1 << '\n';
                ls[i].pop_back();
                rs[ce.u - pw].pop_back();
            }
        }
    }
}
